/* Listato 130 */

/* traccia una rosa con n petali della forma rho = a * cos(n*theta) */

#define Leaves		(double)11	/* n deve essere un numero dispari */

#define	Xmax		640
#define	Ymax		350
#define PixelValue	14
#define	ScaleFactor	(double) 1.37

main()
{
	int	x,y;			/* coordinate di pixel */
	double	a;			/* lunghezza del semiasse */
	double	rho,theta;		/* coordinate polari */

	double	pi = 3.14159265358979;
	double	sin(),cos();

	void SetPixel();


	a = (Ymax / 2) - 1;		/* una scelta ragionevole per a */

	for (theta=0.0; theta < pi; theta+=0.001)
	{
	  rho = a * cos( Leaves*theta );	/* applica la formula */

	  x = rho * cos( theta );	/* converte in coordinate rettangolari */
	  y = rho * sin( theta ) / ScaleFactor;

	  SetPixel( x+Xmax/2, y+Ymax/2, PixelValue );	/* traccia il punto */
	}
}
