		TITLE	'Listato 30'
		NAME	PixelAddr13
		PAGE	55,132

;
; Nome:		PixelAddr13
;
; Funzione:	Determina indirizzo del buffer del pixel nella modalit a 256 colori 320x200
;
; Chiamante:	AX = coordinata y (0-199)
;		BX = coordinata x (0-319)
;
; Ritorna:	BX = offset del byte nel buffer
;		ES = segmento del buffer del video
;


OriginOffset	EQU	0		; offset del byte di (0,0)
VideoBufferSeg	EQU	0A000h

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		PUBLIC	PixelAddr13
PixelAddr13	PROC	near

		xchg	ah,al		; AX := 256*y
		add	bx,ax		; BX := 256*y + x
		shr	ax,1
		shr	ax,1		; AX := 64*y
		add	bx,ax		; BX := 320*y + x

		add	bx,OriginOffset	; BX := offset del byte nel buffer del video

		mov	ax,VideoBufferSeg
		mov	es,ax		; ES:BX := indirizzo del byte del pixel
		ret

PixelAddr13	ENDP

_TEXT		ENDS

		END
