		TITLE	'Listato 50'
		NAME	SetPixel13
		PAGE	55,132

;
; Nome:		SetPixel13
;
; Funzione:	Imposta il valore di un pixel nella modalit a 256 colori 320x200 (MCGA o VGA)
;
; Chiamante:	Microsoft C:
;
;			azzera SetPixel(x,y,n);
;
;			int x,y;		/* coordinate del pixel */
;
;			int n;			/* valore del pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento cornice di stack
ARGy		EQU	word ptr [bp+6]
ARGn		EQU	byte ptr [bp+8]

DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		EXTRN	PixelAddr13:near

		PUBLIC	_SetPixel13
_SetPixel13	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr13	; ES:BX -> buffer

		mov	al,ARGn		; AL := valore del pixel

		jmp	word ptr SetPixelOp13	; salta alla routine di sostituzione,
						;  AND, OR o XOR


ReplacePixel13:	mov	es:[bx],al
		jmp	short L01

ANDPixel13:	and	es:[bx],al
		jmp	short L01

ORPixel13:	or	es:[bx],al
		jmp	short L01

XORPixel13:	xor	es:[bx],al


L01:		mov	sp,bp		; ripristina reg. chiamante e ritorna
		pop	bp
		ret

_SetPixel13	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

SetPixelOp13	DW	ReplacePixel13

_DATA		ENDS

		END
