		TITLE	'Listato 35'
		NAME	ReadPixel06
		PAGE	55,132

;
; Nome:		ReadPixel06
;
; Funzione:	Legge il valore di un pixel nella modalit a 2 colori 640x200
;
; Chiamante:	Microsoft C:
;
;			int ReadPixel06(x,y);
;
;			int x,y;		/* coordinate di pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGy		EQU	word ptr [bp+6]


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr06:near

		PUBLIC	_ReadPixel06
_ReadPixel06	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr06	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare

		mov	al,es:[bx]	; AL := byte contenente il pixel
		shr	al,cl		; sposta valore di pixel su bit meno significativi
		and	al,ah		; AL := valore di pixel
		xor	ah,ah		; AX := valore di pixel

		mov	sp,bp		; ripristina registri chiamante e ritorna
		pop	bp
		ret

_ReadPixel06	ENDP

_TEXT		ENDS

		END
