		TITLE	'Listato 42'
		NAME	ReadPixel13
		PAGE	55,132

;
; Nome:		ReadPixel13
;
; Funzione:	Legge il valore di un pixel nella modalit a 256 colori 320x200 (MCGA e VGA)
;
; Chiamante:	Microsoft C:
;
;			int ReadPixel13(x,y);
;
;			int x,y;		/* coordinate di pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGy		EQU	word ptr [bp+6]


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr13:near

		PUBLIC	_ReadPixel13
_ReadPixel13	PROC	near

		push	bp		; mantiene registri chiamante
		mov	bp,sp

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr13	; ES:BX -> buffer

		mov	al,es:[bx]	; AL := valore di pixel
		xor	ah,ah		; AX := valore di pixel

		mov	sp,bp
		pop	bp
		ret

_ReadPixel13	ENDP

_TEXT		ENDS

		END
