/* Listato 61 */

Line( x1, y1, x2, y2, n )
int	x1,y1;			/* estremit */
int	x2,y2;			/* estremit */
int	n;			/* valore del pixel */
{
	int	x,y;
	float	m;		/* inclinazione */
	float	b;		/* incrocio y */


	if (x2 == x1)				/* linea verticale */
	{
	  if (y1 > y2)
	   Swap( &y1, &y2 );			/* forza y1 < y2 */

	  for (y=y1; y<=y2; y++)		/* traccia da y1 a y2 */
	   SetPixel( x1, y, n );

	  return;
	}

	if (x1 > x2)				/* forza x1 < x2 */
	{
	  Swap( &x1, &x2 );
	  Swap( &y1, &y2 );
	}


	m = (float)(y2-y1) / (float)(x2-x1);	/* calcola m e b */
	b = y1 - (m*x1);

	for (x=x1; x<=x2; x++)			/* traccia da x1 a x2 */
	{
	  y = m*x + b;
	  SetPixel( x, y, n );
	}
}

Swap( a, b )			/* scambia valori di a e b */
int	*a,*b;
{
	int	t;

	t = *a;
	*a = *b;
	*b = t;
}
