
		TITLE	'Listato 2'
		NAME	GetVmode
		PAGE	55,132

;
; Nome:		GetVmode
;
; Funzione:	Richiama BIOS ROM del PC IBM per impostare una
;			modalit video.
;
; Chiamante:	Microsoft C:
;
;			int	GetVmode();
;

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		PUBLIC	_GetVmode
_GetVmode	PROC	near

		push	bp		; conserva registri del chiamante
		mov	bp,sp

		mov	ah,0Fh		; AH := 0Fh (numero funzione di INT 10h)

		push	bp
		int	10h		; chiama BIOS ROM per avere numero di
					;  modalit video
		pop	bp

		xor	ah,ah		; AX := numero di modalit video

		mov	sp,bp
		pop	bp
		ret

_GetVmode	ENDP

_TEXT		ENDS

		END
