		TITLE	'Listato 44'
		NAME	SetPixel04
		PAGE	55,132

;
; Nome:		SetPixel04
;
; Funzione:	Imposta il valore di un pixel nella modalit a 4 colori 320x200
;
; Chiamante:	Microsoft C:
;
;			azzera SetPixel(x,y,n);
;
;			int x,y;		/* coordinate di pixel */
;
;			int n;			/* valore di pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGy		EQU	word ptr [bp+6]
ARGn		EQU	byte ptr [bp+8]


DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		EXTRN	PixelAddr04:near

		PUBLIC	_SetPixel04
_SetPixel04	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr04	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare a sinistra

		mov	al,ARGn
		shl	ax,cl		; AH := maschera di bit nella posizione corretta
					; AL := valore di pixel nella posizione corretta

		jmp	word ptr SetPixelOp04	; salta a routine di sostituzione,
						;  AND, OR o XOR


					; routine per sostituire valore di pixel

ReplacePixel04:	not	ah		; AH := inverte maschera di bit
		and	es:[bx],ah	; azzera il valore di pixel
		or	es:[bx],al	; imposta il valore di pixel
		jmp	short L02

					; routine per effettuare l'AND del valore del pixel

ANDPixel04:	not	ah		; AH := inversione di maschera di bit
		or	al,ah		; AL := tutti i valori di pixel eccetto gli 1
		and	es:[bx],al
		jmp	short L02
				
					
ORPixel04:	or	es:[bx],al	; routine per eseguire OR del valore del pixel
		jmp	short L02


XORPixel04:	xor	es:[bx],al	; routine per eseguire XOR del valore del pixel
		

L02:		mov	sp,bp		; ripristina reg. chiamante e ritorna
		pop	bp
		ret

_SetPixel04	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

SetPixelOp04    DW      ReplacePixel04  ; contiene indirizzo dell'operazione del pixel

_DATA		ENDS

		END
