		TITLE	'Listato 38'
		NAME	ReadPixel0F
		PAGE	55,132

;
; Nome:		ReadPixel0F
;
; Funzione:	Legge il valore di un pixel nella modalit monocromatica 640x350
;
; Chiamante:	Microsoft C:
;
;			int	ReadPixel0F(x,y);
;
;			int x,y;		/* coordinate di pixel*/
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGy		EQU	word ptr [bp+6]


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr10:near

		PUBLIC	_ReadPixel0F
_ReadPixel0F	PROC	near

		push	bp		; mantiene registri chiamante
		mov	bp,sp
		push	si

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr10	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare

; concatena bit dei piani di bit 2 e 0

		mov	ch,ah
		shl	ch,cl		; CH := maschera di bit nella posizione corretta
		mov	si,bx		; ES:SI -> byte del buffer

		mov	dx,3CEh		; DX := porta del controller grafico
		mov	ax,204h		; AH := numero iniziale del piano di bit
					; AL := numero reg. selezione mappa lettura

		xor	bl,bl		; BL  usato per accumulare il valore di pixel

L01:		out	dx,ax		; (come sopra)
		mov	bh,es:[si]
		and	bh,ch
		neg	bh

		rol	bx,1
		sub	ah,2
		jge	L01

		mov	al,bl
		xor	ah,ah

		pop	si
		mov	sp,bp
		pop	bp
		ret

_ReadPixel0F	ENDP

_TEXT		ENDS

		END
