		TITLE	'Listato 39'
		NAME	ReadPixel10
		PAGE	55,132

;
; Nome:		ReadPixel10
;
; Funzione:	Legge il valore di un pixel nelle modalit 640x350 su EGA con 64K
;
; Chiamante:	Microsoft C:
;
;			int	ReadPixel10(x,y);
;
;			int x,y;		/* coordinate di pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento della cornice di stack
ARGy		EQU	word ptr [bp+6]


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr10:near

		PUBLIC	_ReadPixel10
_ReadPixel10	PROC	near

		push	bp		; mantiene registri chiamante
		mov	bp,sp
		push	si

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr10	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare

; concatena bit dei piani di bit 2 e 0 (indirizzo byte pari)
;  o 3 e 1 (indirizzo byte dispari)

		mov	ch,ah
		shl	ch,cl		; CH := maschera di bit nella posizione corretta

		mov	si,bx		; ES:SI -> byte del buffer

		mov	ah,bl		; AH := byte meno significativo dell'indirizzo
		and	ax,100h		; AH := byte meno significativo dell'indirizzo
					; AL := 0
		add	ax,204h		; AH := numero iniziale piano di bit (2 o 3)
					; AL := numero reg. selezione mappa lettura

		mov	dx,3CEh		; DX := porta controller grafico
		xor	bl,bl		; BL  usato per accumulare il valore di pixel

L01:		out	dx,ax		; (come sopra)
		mov	bh,es:[si]
		and	bh,ch
		neg	bh

		rol	bx,1
		sub	ah,2
		jge	L01

		mov	al,bl
		xor	ah,ah

		pop	si
		mov	sp,bp
		pop	bp
		ret

_ReadPixel10	ENDP

_TEXT		ENDS

		END
