/* Listato 79 */

#define	UP		-1
#define	DOWN		1


LineAdjFill( SeedX, SeedY, D, PrevXL, PrevXR )
int	SeedX,SeedY;		/* seme per riga corrente di pixel */
int	D;			/* direzione ricerca per scoprire riga corrente */
int	PrevXL,PrevXR;		/* estremit della riga precedente di pixel */
{
	int	x,y;
	int	xl,xr;
	int	v;

	y = SeedY;		/* inizializza a coordinate di seme */
	xl = SeedX;
	xr = SeedX;

	ScanLeft( &xl, &y );	/* determina estremit del segmento di linea seme*/
	ScanRight( &xr, &y );

	Line( xl, y, xr, y, FillValue );	/* riempie linea con FillValue */


/* trova e riempie segmenti di linea adiacenti nella stessa direzione */

	for (x=xl; x<=xr; x++)		/* controlla righe adiacenti di pixel */
	{
	  v = ReadPixel( x, y+D );
	  if ( (v!=BorderValue) && (v!=FillValue) )
	    x = LineAdjFill( x, y+D, D, xl, xr );
	}

/* trova e riempie segmenti di linea adiacenti nella direzione opposta */

	for (x=xl; x<PrevXL; x++)
	{
	  v = ReadPixel( x, y-D );
	  if ( (v!=BorderValue) && (v!=FillValue) )
	    x = LineAdjFill( x, y-D, -D, xl, xr );
	}

	for (x=PrevXR; x<xr; x++)
	{
	  v = ReadPixel( x, y-D );
	  if ( (v!=BorderValue) && (v!=FillValue) )
	    x = LineAdjFill( x, y-D, -D, xl, xr );
	}

	return( xr );
}


ScanLeft( x, y )
int	*x,*y;
{
	int	v;


	do
	{
	  --(*x);			/* si sposta a sinistra di un pixel  */
	  v = ReadPixel( *x, *y );	/* determina il suo valore */
	}
	while ( (v!=BorderValue) && (v!=FillValue) );

	++(*x);		/* coordinata x del pixel all'estrema sin. di riga */
}


ScanRight( x, y )
int	*x,*y;
{
	int	v;


	do
	{
	  ++(*x);			/* si sposta a destra di un pixel */
	  v = ReadPixel( *x, *y );	/* determina il suo valore */
	}
	while ( (v!=BorderValue) && (v!=FillValue) );

	--(*x);		/* coordin. x del pixel all'estrema destra di riga */
}
